%define __python /usr/bin/python2.7
%global pyver 27

%define destdir /usr/local/python/2.7/pysparse-mkl/%{version}

# type: string (root path to install modulefiles)
%{!?modulefile_path: %global modulefile_path /usr/local/share/Modules/modulefiles/python/2.7/pysparse-mkl}
# type: string (name of modulefile)
%{!?modulefile_name: %global modulefile_name %{version}}
# The name of the modules RPM.  Can vary from system to system.
# type: string (name of modules RPM)
%{!?modules_rpm_name: %global modules_rpm_name environment-modules}
# 32 or 64?

%ifarch %{ix86}
%define modulebits 32
%else
%define modulebits 64
%endif

%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}
%define modulepython_sitearch %{destdir}/%( echo %{python_sitearch} | cut -d/ -f3- )

%{!?compiler: %global compiler intel140}

%if "%{compiler}" == "intel140"
# we will extract versions we need out of above string
%define intelmajor %( echo %{compiler} | cut -b6-7 )
%define intelminor %( echo %{compiler} | cut -b8 )
%define intelversion %{intelmajor}.%{intelminor}
%define intelversionnum %{intelmajor}%{intelminor}
%define extradevel -devel
%{!?intelminrelease: %global intelminrelease 0}
%define compilershort intel
%define compilershortversion intel-%{intelmajor}
%define compilerruntimesection BuildRequires: intel-compiler%{intelmajor}-%{modulebits}-default-modules%{extradevel} >= %{intelversion}-%{intelminrelease}\
Requires: intel-compiler%{intelmajor}-%{modulebits}-default-modules >= %{intelversion}
%define compilerdevelsection Requires: intel-compiler%{intelmajor}-%{modulebits}-default-modules%{extradevel} >= %{intelversion}-%{intelminrelease}
# this is for configuring modules
%define compilermodulename intel-%{intelversion}
%define compilerloadmodule module load intel/%{intelmajor}/%{modulebits}
%endif

Name:           python%{pyver}-pysparse-mkl
Version:        1.3
Release:        0.1%{?dist}
Summary:        A fast sparse matrix library for Python
Group:          Applications/Engineering
License:        BSD
URL:            http://pysparse.sourceforge.net/index.html
Source0:        pysparse-%{version}-dev.tar.bz2
Patch0:         pysparse-1.2-fix-implicit-definitions.patch
Patch1:         pysparse-1.2-fix-no-return-in-nonvoid-function.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  python%{pyver}-devel numpy%{pyver}-mkl python%{pyver}-distribute
BuildRequires:  python%{pyver}-sphinx python%{pyver}-pygments gcc-gfortran
BuildRequires:	environment-modules

%description
Pysparse is a fast sparse matrix library for Python. It provides several sparse
matrix storage formats and conversion methods. It also implements a number of
iterative solvers, preconditioners, and interfaces to efficient factorization
packages. Both low-level and high-level interfaces are available, each with
different strengths.

%prep
%setup -q -n pysparse-%{version}-dev
%patch0 -p1
%patch1 -p1

%build
. /etc/profile.d/modules.sh
module load python/2.7 python/2.7/numpy-mkl
%{compilerloadmodule}
%{__python} setup.py build

%install
. /etc/profile.d/modules.sh
module load python/2.7 python/2.7/numpy-mkl
%{compilerloadmodule}
%{__python} setup.py install -O1 --skip-build --prefix %{_prefix} --root $RPM_BUILD_ROOT

# build doc
PYTHONPATH=$RPM_BUILD_ROOT%{python_sitearch} make -C doc/pysparse PAPER=letter html
rm -f doc/pysparse/build/html/.buildinfo

# now move all of it to our destdir
mkdir -p %{buildroot}%{destdir}
mv %{buildroot}/usr/%{_lib} %{buildroot}%{destdir}/

# module file
mkdir -p %{buildroot}%{modulefile_path}
cat > %{buildroot}%{modulefile_path}/%{modulefile_name} <<ENDMODULE
#%Module

# NOTE: This is an automatically-generated file!  (generated by the
# %{name} RPM).  Any changes made here will be lost a) if the RPM is
# uninstalled, or b) if the RPM is upgraded or uninstalled.

proc ModulesHelp { } {
   puts stderr "This module adds %{name} %{version} to relevant paths"
}

module-whatis   "Sets up %{name} %{version} as default in your environment"


prepend-path PATH "%{destdir}/bin"
prepend-path PYTHONPATH "%{modulepython_sitearch}"
ENDMODULE


%check
. /etc/profile.d/modules.sh
module load python/2.7 python/2.7/numpy-mkl
%{compilerloadmodule}
%{__python} setup.py test

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc CHANGES LICENSE README TODO examples test doc/pysparse/build/html
%{modulepython_sitearch}/*
%dir %{modulefile_path}
%{modulefile_path}/%{modulefile_name}

%changelog
* Wed Dec 28 2011 Huaren Zhong <huaren.zhong@gmail.com> - 1.2
- Rebuild for Fedora

* Sat Apr 02 2011 scorot@gtt.fr
- Fix no-return-in-non-void-function

* Fri Apr 01 2011 scorot@gtt.fr
- first package
